﻿/**
 *	MiniBatteryStatus Widget
 *
 *	© Claudio Procida 2005-2008
 *
 *	Disclaimer
 *
 *	The MiniBatteryStatus Widget software (from now, the "Software") and the accompanying materials
 *	are provided “AS IS” without warranty of any kind. IN NO EVENT SHALL THE AUTHOR(S) BE
 *	LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
 *	INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 *	IF THE AUTHOR(S) HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. The entire risk as to
 *	the results and performance of this software is assumed by you. If the software is
 *	defective, you, and not its author(s), assume the entire cost of all necessary servicing,
 *	repairs and corrections. If you do not agree to these terms and conditions, you may not
 *	install or use this software.
 */

/**
 *	ArcoIris Engine
 */

var ArcoIris = {
	update: function(state)
	{
		if (state.plugged)
		{
			showObj("plugged");
			hideObj("empty");
			hideObj("critical");
			hideObj("low");
			hideObj("high");
			hideObj("full");
		}
		else
		{
			hideObj("plugged");		
			showObj("empty");
			showObj("critical");
			showObj("low");
			showObj("high");
			showObj("full");
			
			var charge = limit_3(state.charge, 0, 100);
	
			this.setTransparency("full", charge, 75);
			this.setTransparency("high", charge, 50);
			this.setTransparency("low", charge, 25);
			this.setTransparency("critical", charge, 0);
			this.setTransparency("empty", charge, -25);
		}
	},
        
	setTransparency: function(id, percent, offset)
	{
		if (typeof System != 'undefined')
		{
			// That shit of Windows Sidebar doesn't support opacity :()
			getObj(id).style.filter = 'alpha(opacity=' + 
				Math.floor(this._transparency(percent, offset) * 100) + ')';
		}
		else
		{
			getObj(id).style.opacity = this._transparency(percent, offset);
		}
	},
	
	_transparency: function(percent, offset)
	{
		// returns 0 when percent is less than offset, 1 when greater than offset + 25, 0 when greater than offset + 50
		return percent <= offset ? 0 : percent >= offset + 50 ? 0 : percent >= offset + 25 ? 1 : (percent - offset) / 25;
	}
};